CREATE OR REPLACE
TRIGGER insert_idTipusCens
  BEFORE INSERT ON TIPUSCENS
  FOR EACH ROW
BEGIN
  SELECT SQ_idTipusCens.NEXTVAL INTO :NEW.idtipuscens
  FROM DUAL;
END insert_idTipusCens;
/
-- -----------------------------------------------------------------------------  
CREATE OR REPLACE
TRIGGER insert_id_CensEstatal
  BEFORE INSERT ON CensEstatal
  FOR EACH ROW
BEGIN
  SELECT SQ_idCensEstatal.NEXTVAL INTO :NEW.idpais
  FROM DUAL;
END insert_idCensEstatal;
/
-- -----------------------------------------------------------------------------  
CREATE OR REPLACE
TRIGGER insert_idCensRegional
  BEFORE INSERT ON CensRegional
  FOR EACH ROW
BEGIN
  SELECT SQ_idCensRegional.NEXTVAL INTO :NEW.idregio
  FROM DUAL;
END insert_idCensRegional;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idCensLocal
  BEFORE INSERT ON CensLocal
  FOR EACH ROW
BEGIN
  SELECT SQ_idCensLocal.NEXTVAL INTO :NEW.idlocal
  FROM DUAL;
END insert_idCensLocal;
/
-- -----------------------------------------------------------------------------  
CREATE OR REPLACE
TRIGGER insert_idCiutada
  BEFORE INSERT ON Ciutada
  FOR EACH ROW
BEGIN
  SELECT SQ_idCiutada.NEXTVAL INTO :NEW.idciutada
  FROM DUAL;
END insert_idCiutada;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idVotacio
  BEFORE INSERT ON Votacio
  FOR EACH ROW
BEGIN
  SELECT SQ_idVotacio.NEXTVAL INTO :NEW.idvotacio
  FROM DUAL;
END insert_idVotacio;
/
-- -----------------------------------------------------------------------------

CREATE OR REPLACE
TRIGGER insert_idAmbit
  BEFORE INSERT ON Ambit
  FOR EACH ROW
BEGIN
  SELECT SQ_idAmbit.NEXTVAL INTO :NEW.idambit
  FROM DUAL;
END insert_idAmbit;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idCensCiutadans
  BEFORE INSERT ON CensCiutadans
  FOR EACH ROW
BEGIN
  SELECT SQ_idCensCiutadans.NEXTVAL INTO :NEW.idcensciutadans
  FROM DUAL;
END insert_idCensCiutadans;
/
-- -----------------------------------------------------------------------------  
CREATE OR REPLACE
TRIGGER insert_idOpcionsVotacioTancada
  BEFORE INSERT ON OpcionsVotacioTancada
  FOR EACH ROW
BEGIN
  SELECT SQ_idOpcionsVotacioTancada.NEXTVAL INTO :NEW.idopvottancada
  FROM DUAL;
END insert_idOpcionsVotacioTancada;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idVotacioTancada
  BEFORE INSERT ON VotacioTancada
  FOR EACH ROW
BEGIN
  SELECT SQ_idVotacioTancada.NEXTVAL INTO :NEW.idVotaciotancada
  FROM DUAL;
END insert_idVotacioTancada;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idLog
  BEFORE INSERT ON Logs
  FOR EACH ROW
BEGIN
  SELECT SQ_idLogs.NEXTVAL INTO :NEW.idlog
  FROM DUAL;
END insert_idLog;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idTipusEstadistica
  BEFORE INSERT ON TipusEstadistica
  FOR EACH ROW
BEGIN
  SELECT SQ_idTipusEstadistica.NEXTVAL INTO :NEW.idtipuse
  FROM DUAL;
END insert_idTipusEstadistica;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idEst13
  BEFORE INSERT ON Est13
  FOR EACH ROW
BEGIN
  SELECT SQ_idEst13.NEXTVAL INTO :NEW.codi
  FROM DUAL;
END insert_idEst13;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idEst46
  BEFORE INSERT ON Est46
  FOR EACH ROW
BEGIN
  SELECT SQ_idEst46.NEXTVAL INTO :NEW.codi
  FROM DUAL;
END insert_idEst46;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idEst79
  BEFORE INSERT ON Est79
  FOR EACH ROW
BEGIN
  SELECT SQ_idEst79.NEXTVAL INTO :NEW.codi
  FROM DUAL;
END insert_idEst79;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER insert_idEst10
  BEFORE INSERT ON Est10
  FOR EACH ROW
BEGIN
  SELECT SQ_idEst10.NEXTVAL INTO :NEW.codi
  FROM DUAL;
END insert_idEst10;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER ALTA_CENS_GLOBAL AFTER INSERT ON CIUTADA 
FOR EACH ROW 

BEGIN

        INSERT INTO censciutadans 
                  (idciutada, idcodicens,idtipuscens)
           VALUES (:NEW.idciutada, 1,1);
       

    END;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER ACTUALITZA_NUM_CIUTADANS AFTER INSERT ON VOTACIONSCIUTADA 
FOR EACH ROW 
BEGIN
                  
           update VOTACIO set numtotalsciutadans= numtotalsciutadans + 1
           where idvotacio= :NEW.idvotacio;
      

    END;
/
-- -----------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER ACTUALITZA_E4 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE          VARCHAR2(1);
n_anno          NUMBER;
n_participacio  NUMBER;

  
  
 BEGIN
       SELECT EXTRACT(YEAR FROM datainici)
        INTO n_anno
        FROM VOTACIO
        WHERE idvotacio= :new.idvotacio;
  
       SELECT 'S'
         INTO EXISTE
         FROM EST46
         WHERE  idtipuse         = 4
         AND    anno           = n_anno
         AND ROWNUM            = 1;
         
         SELECT valor
          INTO n_participacio
          FROM EST46
          WHERE idtipuse      = 4
          AND anno            = n_anno;
          
          IF (:new.pparticipacio>n_participacio)THEN
        
         UPDATE EST46 set valor= :new.idvotacio, idv= :new.idvotacio 
         where idtipuse     = 4
         AND   anno  = n_anno;
         END IF;
         
         
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
          INSERT INTO EST46 (idtipuse, anno, valor, idv) 
                 VALUES (4, n_anno, :new.pparticipacio, :new.idvotacio);
     END;    
/
-----------------------------------------------------------------------------
  
create or replace TRIGGER ACTUALITZA_LOC_VOTACIO BEFORE INSERT ON VOTACIONSCIUTADA 
FOR EACH ROW 
DECLARE
n_idlocalitat     NUMBER;

BEGIN
SELECT idcodicens
INTO n_idlocalitat
FROM CENSCIUTADANS
where idciutada = :new.idciutada
AND idtipuscens = 4;
                  
        :new.idlocalitat := n_idlocalitat;   
      

    END;
/
-- -----------------------------------------------------------------------

create or replace TRIGGER ACTUALITZA_E5 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE                 VARCHAR2(1);
n_idlocalitat          NUMBER;
n_participacio         NUMBER;
n_ANNO                 NUMBER;

  
  
 BEGIN
 select *
 INTO n_idlocalitat, n_participacio, n_ANNO
 FROM(SELECT idlocalitat,SUM(participacio)as part, anno
      FROM votacionsciutada
      GROUP BY idlocalitat, participacio, anno
      ORDER BY part DESC)
 WHERE ROWNUM=1;
       
               
  
       SELECT 'S'
         INTO EXISTE
         FROM EST46
         WHERE  idtipuse         = 5
         AND    anno           = n_anno
         AND ROWNUM            = 1;
         
               
         UPDATE EST46 set valor=n_participacio, idv= n_idlocalitat
         where idtipuse     = 5
         AND   anno  = n_anno;           
         
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
          INSERT INTO EST46 (idtipuse, anno, valor, idv) 
                 VALUES (5, n_anno, n_participacio, n_idlocalitat);
     END;         
/
-- -----------------------------------------------------------------------

create or replace TRIGGER ACTUALITZA_E6 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE                 VARCHAR2(1);
n_numtotalciutadans    NUMBER;
n_numciutadans         NUMBER;
n_ANNO                 NUMBER;

  
  
 BEGIN
 SELECT COUNT(*) 
        INTO n_numciutadans
        FROM ciutada 
        WHERE numvotsemesos=0;
        
 SELECT COUNT(*) 
        INTO n_numtotalciutadans
        FROM ciutada; 
        
 
 SELECT EXTRACT(YEAR FROM datainici)
        INTO n_anno
        FROM VOTACIO
        WHERE idvotacio= :new.idvotacio;
       
               
  
       SELECT 'S'
         INTO EXISTE
         FROM EST46
         WHERE  idtipuse       = 6
         AND    anno           = n_anno
         AND ROWNUM            = 1;
         
               
         UPDATE EST46 set valor=(n_numciutadans/n_numtotalciutadans)*100, idv= 
n_numciutadans
         where idtipuse     = 6
         AND   anno  = n_anno;               
         
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
          INSERT INTO EST46 (idtipuse, anno, valor, idv) 
                 VALUES (6, n_anno, (n_numciutadans/n_numtotalciutadans)*100, 
n_numciutadans);
     END; 
/
-- -----------------------------------------------------------------------

create or replace TRIGGER ACTUALITZA_E7 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE                 VARCHAR2(1);
n_participacio         NUMBER;
  
 BEGIN
  
 SELECT 'S'
       INTO EXISTE
       FROM EST79
       WHERE  idtipuse       = 7
       AND ROWNUM            = 1;         
        
         SELECT valor
        INTO n_participacio
        FROM EST79
        WHERE idtipuse=7;
        
       IF (:NEW.pparticipacio>n_participacio)THEN       
         UPDATE EST79 set valor= :NEW.pparticipacio, votacio= 
:NEW.idvotacio
         where idtipuse     = 7;   
         END IF;
         
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
       
       
          INSERT INTO EST79 (idtipuse, votacio, valor) 
                 VALUES (7, :NEW.idvotacio, :NEW.pparticipacio);
       
     END;         
  
  
/
-- -----------------------------------------------------------------------

create or replace TRIGGER ACTUALITZA_E8 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE                 VARCHAR2(1);
n_dif                  NUMBER;

  
 BEGIN
 
 SELECT 'S'
       INTO EXISTE
       FROM EST79
       WHERE  idtipuse       = 8
       AND ROWNUM            = 1;         
         
        SELECT valor
        INTO n_dif
        FROM EST79
        WHERE idtipuse=8;
        
       IF (:NEW.popguanyadora-:NEW.popmenysvotada>n_dif)THEN      
         UPDATE EST79 set valor= (:NEW.popguanyadora-:NEW.popmenysvotada), 
votacio= :NEW.idvotacio
         where idtipuse     = 8;                     
          END IF;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
        
          INSERT INTO EST79 (idtipuse, votacio, valor) 
                 VALUES (8, :NEW.idvotacio, (:NEW.popguanyadora - 
:NEW.popmenysvotada));
      
     END;  
               
               
/
-- -----------------------------------------------------------------------

create or replace TRIGGER ACTUALITZA_E9 AFTER INSERT ON VOTACIOTANCADA 
FOR EACH ROW 
DECLARE 
EXISTE                 VARCHAR2(1);
n_dif                  NUMBER;

  
 BEGIN
 
 SELECT 'S'
       INTO EXISTE
       FROM EST79
       WHERE  idtipuse       = 9
       AND ROWNUM            = 1;         
         
        SELECT valor
        INTO n_dif
        FROM EST79
        WHERE idtipuse=9;
        
       IF (:NEW.popguanyadora-:NEW.popmenysvotada<n_dif)THEN      
         UPDATE EST79 set valor= (:NEW.popguanyadora-:NEW.popmenysvotada), 
votacio= :NEW.idvotacio
         where idtipuse     = 9;                     
          END IF;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
        
          INSERT INTO EST79 (idtipuse, votacio, valor) 
                 VALUES (9, :NEW.idvotacio, (:NEW.popguanyadora - 
:NEW.popmenysvotada));
      
     END;                                
               
/
-- -------------------------------------------------------------------------
CREATE OR REPLACE
TRIGGER DELETE_AMBIT BEFORE DELETE ON AMBIT 
FOR EACH ROW 
DECLARE
 n_idvotacio_ins            NUMBER;
   n_idtipuscens_ins          NUMBER;
   n_idcodicens_ins           NUMBER;
   n_idpais_ins               VARCHAR2(2);
   n_idregio_ins              NUMBER;
   n_any_ins                  NUMBER;
   n_valor_ins                NUMBER;              
   err_msg                    VARCHAR2 (100);
   existe                     VARCHAR2(1);
   N                          NUMBER:=0;
   campsNuls                  EXCEPTION;
   votacioInexistent          EXCEPTION;
   tipuscensInexistent        EXCEPTION;
   codicensInexistent         EXCEPTION;
   
  -- cursor del cens global que llista tots els pasos, les regions i les localitats 
   CURSOR CUR_GLOBAL_ESTATAL IS
        SELECT idpais
         FROM CENSESTATAL;
         
   CURSOR CUR_GLOBAL_REGIONAL IS
        SELECT idregio
        FROM CENSREGIONAL;
        
   CURSOR CUR_GLOBAL_LOCAL IS
        SELECT idlocal
         FROM CENSLOCAL;
         
  -- cursor del cens estatal que llista totes les regions i les localitats
  
  CURSOR CUR_ESTATAL_REGIONAL IS
        SELECT idregio
        FROM CENSREGIONAL
        WHERE IDPAIS= n_idpais_ins;
        
   CURSOR CUR_ESTATAL_LOCAL IS
        SELECT idlocal
         FROM CENSLOCAL
         WHERE IDPAIS= n_idpais_ins;
         
  -- cursor del cens regional que llista totes les localitats
  
  CURSOR CUR_REGIONAL_LOCAL IS
        SELECT idlocal
         FROM CENSLOCAL
         WHERE IDREGIO= n_idcodicens_ins;
  
   
BEGIN
   n_idvotacio_ins    := :OLD.idvotacio;
   n_idtipuscens_ins  := :OLD.idtipuscens;
   n_idcodicens_ins   := :OLD.codicens;  
      
 
 -- extraiem l'any de la votaci
 SELECT  EXTRACT(YEAR FROM datainici) 
 INTO  n_any_ins
 FROM votacio 
 WHERE idvotacio= n_idvotacio_ins;
 
 -- si el cens es global, per tots els censos donats d'alta mirem si el valor s =1 
 -- si s aix esborrem el registre, en cas contrari decrementem el valor en 1
 IF (n_idtipuscens_ins=1) THEN
  FOR R IN CUR_GLOBAL_ESTATAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 2
         AND   codicens        = R.idpais
         AND anno              = n_any_ins;
        
        IF(n_valor_ins=1) THEN
         DELETE FROM EST13
          WHERE tipuse      = 3
          AND tipuscens     = 2
          AND codicens      = R.idpais
          AND anno          = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1)THEN
         UPDATE EST13 set valor=valor - 1 
          WHERE tipuse     = 3
          AND   tipuscens  = 2
          AND   codicens   = R.idpais
          AND   anno       = n_any_ins;
        END IF; 
        END;
  END LOOP;
  
  FOR R IN CUR_GLOBAL_REGIONAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 3
         AND   codicens        = R.idregio
         AND anno              = n_any_ins;
         
         IF (n_valor_ins=1) THEN
          DELETE FROM EST13
           WHERE  tipuse         = 3
           AND    tipuscens      = 3
           AND   codicens        = R.idregio
           AND anno              = n_any_ins;
         END IF;
         
         IF (n_valor_ins>1) THEN
          UPDATE EST13 set valor=valor - 1 
           WHERE tipuse     = 3
           AND   tipuscens  = 3
           AND   codicens   = R.idregio
           AND   anno       = n_any_ins;
         END IF; 
         END;
  END LOOP;
  
 FOR R IN CUR_GLOBAL_LOCAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 4
         AND   codicens        = R.idlocal
         AND anno              = n_any_ins;
        
        IF (n_valor_ins=1) THEN
         DELETE FROM EST13
          WHERE  tipuse         = 3
          AND    tipuscens      = 4
          AND   codicens        = R.idlocal
          AND anno              = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
         where tipuse     = 3
         AND   tipuscens  = 4
         AND   codicens   = R.idlocal
         AND   anno       = n_any_ins;
        END IF; 
        END;
  END LOOP;
  
  END IF;
 -- si el cens es Estatal, per tots els censos associats al pas mirem si el valor s =1 
 -- si s aix esborrem el registre, en cas contrari decrementem el valor en 1
  IF (n_idtipuscens_ins=2) THEN
      
     BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE tipuse             = 3
         AND   tipuscens          = n_idtipuscens_ins
         AND   codicens           = n_idcodicens_ins
         AND anno                 = n_any_ins;
         
        IF (n_valor_ins=1) THEN
         DELETE FROM EST13
          WHERE tipuse             = 3
          AND   tipuscens          = n_idtipuscens_ins
          AND   codicens           = n_idcodicens_ins
          AND anno                 = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
          WHERE tipuse         = 3
          AND   tipuscens      = n_idtipuscens_ins
          AND   codicens       = n_idcodicens_ins
          AND   anno           = n_any_ins;
        END IF;       
     END;  
    
    SELECT codipais 
    INTO   n_idpais_ins
    FROM CENSESTATAL
    WHERE idpais=n_idcodicens_ins;
         
    FOR R IN CUR_ESTATAL_REGIONAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 3
         AND   codicens        = R.idregio
         AND anno              = n_any_ins;
         
        IF (n_valor_ins=1) THEN
        DELETE FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 3
         AND   codicens        = R.idregio
         AND anno              = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
         where tipuse     = 3
         AND   tipuscens  = 3
         AND   codicens   = R.idregio
         AND   anno       = n_any_ins;
        END IF;
     END;         
  END LOOP;
  
   FOR R IN CUR_ESTATAL_LOCAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 4
         AND   codicens        = R.idlocal
         AND anno              = n_any_ins;
         
        IF (n_valor_ins=1) THEN
         DELETE FROM EST13
          WHERE  tipuse         = 3
          AND    tipuscens      = 4
          AND   codicens        = R.idlocal
          AND anno              = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
         WHERE tipuse     = 3
         AND   tipuscens  = 4
         AND   codicens   = R.idlocal
         AND   anno       = n_any_ins;
         END IF;
         END;
  END LOOP;
  END IF;
  
 -- si el cens es Regional, per tots els censos associats al pas mirem si el valor s =1 
 -- si s aix esborrem el registre, en cas contrari decrementem el valor en 1
  IF (n_idtipuscens_ins=3) THEN
   BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE tipuse             = 3
         AND   tipuscens          = n_idtipuscens_ins
         AND   codicens           = n_idcodicens_ins
         AND anno                 = n_any_ins;
         
        IF (n_valor_ins=1) THEN
         DELETE FROM EST13
         WHERE tipuse             = 3
         AND   tipuscens          = n_idtipuscens_ins
         AND   codicens           = n_idcodicens_ins
         AND anno                 = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
         where tipuse         = 3
         AND   tipuscens      = n_idtipuscens_ins
         AND   codicens       = n_idcodicens_ins
         AND   anno           = n_any_ins;
        END IF;
    END;
             
    FOR R IN CUR_REGIONAL_LOCAL LOOP
    N := N + 1;
    BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE  tipuse         = 3
         AND    tipuscens      = 4
         AND   codicens        = R.idlocal
         AND anno              = n_any_ins;
         
         IF (n_valor_ins=1) THEN
          DELETE FROM EST13
          WHERE  tipuse         = 3
          AND    tipuscens      = 4
          AND   codicens        = R.idlocal
          AND anno              = n_any_ins;
         END IF;
        
        IF (n_valor_ins>1) THEN
         UPDATE EST13 set valor=valor - 1 
         where tipuse     = 3
         AND   tipuscens  = 4
         AND   codicens   = R.idlocal
         AND   anno       = n_any_ins;
        END IF;
        END;
  END LOOP;
  END IF;
  
 -- si el cens es Local, mirem si  valor=1 
 -- si s aix esborrem el registre, en cas contrari decrementem el valor en 1
  IF (n_idtipuscens_ins=4) THEN
 BEGIN
       SELECT valor
         INTO n_valor_ins
         FROM EST13
         WHERE tipuse             = 3
         AND   tipuscens          = n_idtipuscens_ins
         AND   codicens           = n_idcodicens_ins
         AND   anno               = n_any_ins;
         
         IF (n_valor_ins=1) THEN
          DELETE FROM EST13
          WHERE tipuse             = 3
          AND   tipuscens          = n_idtipuscens_ins
          AND   codicens           = n_idcodicens_ins
          AND   anno               = n_any_ins;
        END IF;
        
        IF (n_valor_ins>1)THEN
         UPDATE EST13 set valor=valor - 1 
         where tipuse         = 3
         AND   tipuscens      = n_idtipuscens_ins
         AND   codicens       = n_idcodicens_ins
         AND   anno           = n_any_ins;
        END IF;
        END;
  END IF;    
      

    END;
/
-- --------------------------------------------------------------------------