DECLARE
  RST VARCHAR2(20000);
BEGIN
-- proves procediments d'alta

altaCensEstatal(null,null, rst); 	       -- ERROR: el nom i el codi del Pas no poden ser nuls
altaCensEstatal('ES','ESPANYA', rst);          -- ERROR: Aquest pas ja ha estat donat d alta al cens

altaCensregional(null,null, rst);              -- ERROR: el nom de la regio i el codi del Pas no poden ser nuls
altaCensregional('ES','Catalunya', rst);       -- ERROR: Aquesta Regi ja ha estat donada d alta al cens
altaCensregional('QQ','Catalunya', rst);       -- ERROR: El Pas no ha estat donat d alta al sistema

altaCensLocal('ES',null, 'Girona', rst);       -- ERROR: el nom de la localitat, el codi de la regio i el codi del Pas no poden ser nuls
altaCensLocal('ES',1, 'Girona', rst);          -- ERROR: Aquesta localitat ja ha estat donada d alta al cens
altaCensLocal('QQ',1, 'Girona', rst);          -- ERROR: El Pas no ha estat donat d alta al sistema
altaCensLocal('ES',3625, 'Girona', rst);       -- ERROR: La Regi no ha estat donat d alta al sistema

altaCiutada(null,'27/01/1998', rst);           -- ERROR: El codi del ciutada i la data de naixement no poden ser nuls
altaCiutada('AAA000000AA','27/01/1990', rst);  -- ERROR: Aquest ciutada ja ha estat donat d alta al sistema
altaCiutada('AAA000999AA','27/01/2008', rst);  -- ERROR: Aquest Ciutada s menor d edat i no es pot donar d alta al sistema

altaVotacio(null,
'descripcio de la votacio','21/01/2012',
'29/01/2012', '10/01/2012',1, 
'http://www.planaweb.org', rst);             -- ERROR: hi ha camps nuls que no poden ser nuls
altaVotacio('votacio 2491',
'descripcio de la votacio','21/01/2012',
'29/01/2012', '10/01/2012',125, 
'http://www.planaweb.org', rst);             -- ERROR:  El ciutad que es vol introduir com a president no existeix
altaVotacio('votacio 2987',
'descripcio de la votacio','21/01/2012',
'29/01/2012', '17/01/2012',1, 
'http://www.planaweb.org', rst);             -- ERROR: la data de publicaci de la votaci ha de ser com a mnim
                                                -- una setmana abans que la d'inici de la votaci
altaVotacio('votaci 2999',
'descripcio de la votacio','31/01/2012',
'29/01/2012', '10/01/2012',1, 
'http://www.planaweb.org', rst);             -- ERROR: la data de finalitzaci no pot ser anterior ni igual que la d inici de la votacio

altaOpcioVot(1,null,'descripcio opcio', rst);   -- ERROR: camps nuls
altaOpcioVot(54,1,'descripcio opcio', rst);     -- ERROR: la votaci no existeix
altaOpcioVot(1,1,'descripcio opcio', rst);      -- ERROR: la opci ja ha estat donada d alta al sistema prviament

altaAmbit(1,null,1, rst);                       -- ERROR: el codi de la votaci, el codi del cens i el tipus de cens no poden ser nuls
altaAmbit(128,1,1, rst);                        -- ERROR: La votaci no existeix
altaAmbit(1,1,1, rst);                          -- ERROR: Aquest cens ja ha estat assignat a aquesta votacio
altaAmbit(1,12,1, rst);                         -- ERROR: El tipus de cens no existeix
altaAmbit(1,2,111, rst);                        -- ERROR: El cens no existeix
altaAmbit(1,1,2, rst);				-- ERROR: El cens est donat de baixa


altaCensCiutada(1,1,null, rst);                 -- ERROR: el codi del ciutada, el codi del cens i el tipus de cens no poden ser nuls
altaCensCiutada(1,1,1, rst);                    -- ERROR: Aquest ciutada ja ha estat assignat a aquest cens
altaCensCiutada(1256,1,1, rst);                 -- ERROR: El ciutada no existeix
altaCensCiutada(15,35,2, rst);                   -- ERROR: El tipus de cens no existeix
altaCensCiutada(15,2,105, rst);                  -- ERROR: El cens no existeix


-- proves procediments de baixa

baixaAmbit(1,null,1, rst);                      -- ERROR: el codi de la votaci, el codi del cens i el tipus de cens no poden ser nuls
baixaAmbit(2,1,1, rst); 			-- ERROR: Aquest mbit no existeix
baixaAmbit(3,1,3, rst);                         -- ERROR: La votaci ja est oberta
baixaAmbit(1,1,1, rst);                         -- ERROR: La votaci ja est tancada

baixaCensCiutada(null,1,1, rst);                -- ERROR: el codi del ciutada, el codi del cens i el tipus de cens no poden ser nuls
baixaCensCiutada(1,1,1, rst);			-- OK
baixaCensCiutada(1,1,1, rst);                   -- ERROR: Aquest ciutada ja ha estat donat de baixa en aquest cens
baixaCensCiutada(188,1,1, rst);                 -- ERROR: El ciutada no existeix
baixaCensCiutada(1,1,12, rst);                  -- ERROR: El tipus de cens no existeix
baixaCensCiutada(1,58,2, rst);                  -- ERROR: El cens no existeix

BaixaCensEstatal(null, rst);                    -- ERROR: el codi del pas no pot ser nul
BaixaCensEstatal('DE', rst);                    -- OK
BaixaCensEstatal('DE', rst);                    -- ERROR: Aquest pas ja ha estat donada de baixa al cens
altaAmbit(3,2,1, rst);                          -- ERROR: El cens ha estat donat de baixa
altaCensCiutada(1,1,2, rst);			-- ERROR: El cens est inactiu
altaAmbit(1,1,2, rst);				-- ERROR: El cens est donat de baixa
BaixaCensEstatal('QQ', rst);                    -- ERROR: El pas no ha estat donat d alta al sistema

BaixaCensLocal(null, rst);                      -- ERROR: el codi de la localitat no pot ser nul
BaixaCensLocal(1, rst);				-- OK
BaixaCensLocal(1, rst);                         -- ERROR: Aquesta localitat ja ha estat donada de baixa al cens
BaixaCensLocal(1041, rst);                      -- ERROR: La Localitat no ha estat donada d alta al sistema

BaixaCensRegional(null, rst);                   -- ERROR: el codi de la regi no pot ser nul
BaixaCensRegional(1, rst);			-- OK
BaixaCensRegional(1, rst);                      -- ERROR: Aquesta regi ja ha estat donada de baixa al cens
BaixaCensRegional(1054, rst);                   -- ERROR: La regi no ha estat donat d alta al sistema

baixaCiutada(null, rst);                        -- ERROR: el codi del ciutada no pot ser nul
baixaCiutada('AAA000000AA', rst);               -- OK
baixaCiutada('AAA000000AA', rst);               -- ERROR: Aquest ciutada ja ha estat donat de baixa al sistema
altaCensCiutada(1,1,1, rst);			-- ERROR: El ciutada Est inactiu
baixaCiutada('AMH658564BS', rst);               -- ERROR: Aquest ciutada no ha estat donat d alta al sistema

baixaOpcioVot(null,1, rst);                     -- ERROR: camps nuls
baixaOpcioVot(125,1, rst);                      -- ERROR: votaci inexistent
baixaOpcioVot(3,1, rst);                        -- ERROR: votaci oberta
baixaOpcioVot(1,1, rst);                        -- ERROR: votaci tancada

baixaVotacio(null, rst);                        -- ERROR: el codi de la votacio i la descripci no poden ser nuls
baixaVotacio(1999, rst);                        -- ERROR: la votaci no existeix
baixaVotacio(3, rst);                           -- ERROR: la votaci ja est oberta
baixaVotacio(1, rst);                           -- ERROR: la votaci ja est tancada

-- proves procediments de modificaci

modAmbit(2,1,1,1, rst);				-- ERROR: La modificaci dona com a resultat un mbit ja existent
modAmbit(127,1,1,1, rst);			-- ERROR: l'ambit no existeix al sistema
modAmbit(2,2,57,2, rst);			-- ERROR: El cens no existeix
modAmbit(2,2,2,16, rst);			-- ERROR: El tipus de cens no existeix
modAmbit(2,25,2,13, rst);			-- ERROR: La votaci no existeix
modAmbit(2,3,2,2, rst);	        		-- ERROR: La votaci ja est oberta
modAmbit(2,2,25,2, rst);        		-- ERROR: La votaci ja est tancada
modAmbit(2,null,null,null, rst);		-- ERROR: el codi de la votaci, el codi del cens i el tipus de cens no poden ser nuls

modCensCiutada(1,1,2,1, rst);			-- ERROR: Aquest censciutada ha estat donat de baixa
modCensCiutada(1,125,1,1, rst);			-- ERROR: Aquest censciutada no existeix al sistema
modCensCiutada(14,2,9,3, rst);			-- ERROR: la modificaci que es vol fer dna com a resultat un censciutada duplicat
modCensCiutada(14,2,99,2, rst);			-- ERROR: El cens no existeix
modCensCiutada(14,2,9,9, rst);			-- ERROR: El tipus de cens no existeix
modCensCiutada(14,99,2,2, rst);			-- ERROR: El ciutada no existeix
modCensCiutada(null,null,null,null, rst);	-- ERROR: el codi del censciutada, el codi del ciutada, el codi del cens i el tipus de cens no poden ser nuls

modCensEstatal('QQ','ESPANYA', rst);		-- ERROR: El pas no ha estat donat d alta al sistema
modCensEstatal(null,null, rst);	        	-- ERROR: el codi del pas i el nom no poden ser nuls
 
modCensLocal(127,'Gerona', rst);		-- ERROR: La Localitat no ha estat donat d alta al sistema
modCensLocal(null,null, rst);			-- ERROR: el codi de la localitat i el nom no poden ser nuls

modCensRegional(99,'CATALUA', rst);		-- ERROR: La regi no ha estat donat d alta al sistema
modCensRegional(null,null, rst);		-- ERROR: el codi de la regi i el nom no poden ser nuls

modCiutada('AMH658564BS', '28/02/1975', rst);	-- ERROR: Aquest ciutada no ha estat donat d alta al sistema
modCiutada('BBB000000AA', '28/02/2000', rst);	-- ERROR: la data de naixement implica que el ciutad es menor d'edat
modCiutada(null, null, rst);			-- ERROR: el codi del ciutada i la data de naixement no poden ser nuls

modOpcioVot(9,1,'descripci ', rst);		-- ERROR: la votaci no existeix
modOpcioVot(3,1,'descripci ', rst);		-- ERROR: la votaci ja est oberta
modOpcioVot(4,1,'descripci ', rst);		-- ERROR: la votaci ja est tancada
modOpcioVot(null,null,null, rst);		-- ERROR: ERROR: el codi de la votacio, el nmero de la opci i la descripci no poden ser nuls


modVotacio(3,'votacio 2491','descripcio',
'21/01/2012','29/01/2012', '10/01/2012',
1, 'http://www.planaweb.org', rst);		-- ERROR: La votaci ja est oberta
modVotacio(1,'votacio 2491','descripcio',
'21/01/2012','29/01/2012', '10/01/2012',
1, 'http://www.planaweb.org', rst);		-- ERROR: la votacio est tancada
modVotacio(9,'votacio 2491','descripcio',
'21/01/2012','29/01/2012', '10/01/2012',
1, 'http://www.planaweb.org', rst);		-- ERROR: la votaci no est donada d alta al sistema
modVotacio(5,'votacio 2491','descripcio',
'21/01/2012','29/01/2012', '10/01/2012',
125, 'http://www.planaweb.org', rst);		-- ERROR: El ciutad que es vol introduir com a president no existeix
modVotacio(5,'votacio 2491','descripcio',
'21/01/2012','29/01/2012', '20/01/2012',
19, 'http://www.planaweb.org', rst);		-- ERROR: la data de publicaci ha de ser com a mnim una setmana abans que la d inici de la votacio
modVotacio(5,'votacio 2491','descripcio',
'31/01/2012','29/01/2012', '10/01/2012',
19, 'http://www.planaweb.org', rst);		-- ERROR: ERROR: la data de finalitzaci no pot ser anterior ni igual que la d inici de la votacio
modVotacio(null,null,'descripcio',
'21/01/2012','29/01/2012', '10/01/2012',
125, 'http://www.planaweb.org', rst);		-- ERROR: hi ha camps nuls que no poden ser nuls

-- proves procediments de funcionament

activarVotacio(null, rst);                       -- ERROR: el codi de la votaci, el codi del cens i el tipus de cens no poden ser nuls
activarVotacio(127, rst);                        -- ERROR: La votaci no existeix
activarVotacio(3, rst);                          -- ERROR: La votaci ja est oberta
activarVotacio(4, rst);                          -- ERROR: La votaci est tancada


votar(null,null,null, rst);                        -- ERROR: el codi del ciutada, el de la votaci i el num de opci no poden ser nuls
votar(1,1,1999, rst);                             -- ERROR: El ciutada no existeix
votar(1999,1,17, rst);                             -- ERROR: La votacio no existeix
votar(1,99,17, rst);                               -- ERROR: La opci no existeix
votar(3,1,40, rst);                               -- ERROR: el ciutada no ha estat convocat a aquesta votaci
votar(1,1,17, rst);                                -- ERROR: El ciutada ja ha votat en aquesta convocatria
votar(4,1,32, rst);                               -- ERROR: La votacio ja ha finalitzat, o encara no est oberta

tancarvotacio(null, rst);                         -- ERROR: el codi  de la votaci no pot ser nul
tancarvotacio(99, rst);                           -- ERROR: La votacio no existeix
tancarvotacio(3, rst);                            -- ERROR: La votacio no ha finalitzat, o encara est oberta
tancarvotacio(4, rst);                            -- ERROR: La votacio ja est tancada

-- proves procediments estadstics

ActualitzaE1 (null, rst);                            -- ERROR: el codi de la votaci no pot ser nul
ActualitzaE1 (99, rst);                              -- ERROR: La votaci no existeix

ActualitzaE2 (null, rst);                            -- ERROR: el codi de la votaci no pot ser nul
ActualitzaE2 (99, rst);                              -- ERROR: La votaci no existeix

ActualitzaE3 (null,null,null, rst);                  -- ERROR: el codi de la votaci, el codi del cens i el tipus de cens no poden ser nuls
ActualitzaE3 (99,1,1, rst);                          -- ERROR: La votaci no existeix


END;


